/*
  CLIgen is a CLI generator.

  ***** BEGIN LICENSE BLOCK *****

  Copyright (C) 2001-2022 Olof Hagsand

  This file is part of CLIgen.

  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.

  Alternatively, the contents of this file may be used under the terms of
  the GNU General Public License Version 2 or later (the "GPL"),
  in which case the provisions of the GPL are applicable instead
  of those above. If you wish to allow use of your version of this file only
  under the terms of the GPL, and not to allow others to
  use your version of this file under the terms of Apache License version 2, indicate
  your decision by deleting the provisions above and replace them with the
  notice and other provisions required by the GPL. If you do not delete
  the provisions above, a recipient may use your version of this file under
  the terms of any one of the Apache License version 2 or the GPL.

  ***** END LICENSE BLOCK *****

*/

/*
   You include cligen.h which includes the other cligen include files for you.
   All cligen include files are placed in the sub-directory cligen/cligen*.h.
*/
#include <stdio.h>
#include <netinet/in.h>

/* CLIgen handle for external API. See cligen_config.h for internal functions. */
#ifndef _CLIGEN_H_
#define _CLIGEN_H_
#if 1 /* SANITY CHECK */
typedef struct {int a;} *cligen_handle;
#else
typedef void *cligen_handle; /* API */
#endif
#endif  /* _CLIGEN_H_ */

#ifdef __cplusplus
extern "C" {
#endif

#include <cligen/cligen_buf.h>
#include <cligen/cligen_cv.h>
#include <cligen/cligen_cvec.h>
#include <cligen/cligen_parsetree.h>
#include <cligen/cligen_pt_head.h>
#include <cligen/cligen_callback.h>
#include <cligen/cligen_object.h>
#include <cligen/cligen_handle.h>
#include <cligen/cligen_print.h>
#include <cligen/cligen_result.h>
#include <cligen/cligen_read.h>
#include <cligen/cligen_io.h>
#include <cligen/cligen_expand.h>
#include <cligen/cligen_syntax.h>
#include <cligen/cligen_util.h>
#include <cligen/cligen_regex.h>
#include <cligen/cligen_history.h>

#ifdef __cplusplus
} /* extern "C" */
#endif

/*
 * Global variables generated by Makefile
 */
extern const char CLIGEN_BUILDSTR[];
extern const char CLIGEN_VERSION[];

